/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.sortwithcomparableinterface;

import java.util.ArrayList;
import java.util.Collections;

/**
 *
 * @author omozegieaziegbe
 */
public class SortWithComparableInterface {

    public static void main(String[] args) {

        ArrayList<Person> people = new ArrayList<>();
        // Add some people to the list
        people.add(new Person("Thomas", 45));
        people.add(new Person("Charles", 50));
        people.add(new Person("Bob", 35));
        people.add(new Person("Jonathan", 60));
        people.add(new Person("Daniel", 12));

        // Sort in ascending order (natural order)
        Collections.sort(people);

        System.out.println("Ascending order:");
        for (Person person : people) {
            System.out.println(person);
        }

        // Sort in descending order by reversing the list
        Collections.reverse(people);

        System.out.println("\nDescending order:");
        for (Person person : people) {
            System.out.println(person);
        }
    }
}

class Person implements Comparable<Person> {

    private String name;
    private int age;

    public Person(String name, int age) {
        this.name = name;
        this.age = age;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    @Override
    public int compareTo(Person otherPerson) {
        return this.name.compareTo(otherPerson.getName());
    }

    @Override
    public String toString() {
        return "Person{" + "name=" + name + ", age=" + age + '}';
    }

}
